// Copyright (c) 2015, Will Squire. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

library functional_behaviour_tree.node;

import 'dart:async';

/// A node (or 'task') has the role of carrying out a given action or condition upon a passed backboard object, returning true upon success and false if unsuccessful. Where an object-orientated AI system
/// would generally pass the blackboard upon initialisation and remain constant,
/// here the node follows a functional approach, taking a blackboard entity on each process so it can be associated with multiplicity of sources. One
/// node can then work upon multiple problem domains without requiring multiple instances.
typedef Future<bool> Node(Object blackboard);